//-------------------------------------------------------------------------------------------------
//            AtaWII Beta 1 Coded By NoNameNo   09-03-2008
//-------------------------------------------------------------------------------------------------







#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>

#include "cpu/68000.h"
#include "st/st.h"

u32 *xfb = NULL;
static GXRModeObj *rmode = NULL;
unsigned    ips = 0;

struct rgb_pal_struct{
	int r;
	int g;
	int b;
};

int AtariBitPlan[16];

struct rgb_pal_struct rgb_pal[16];


void (*reload)() = (void (*) ()) 0x80001800;

u32
CvtRGB (u8 r1, u8 g1, u8 b1, u8 r2, u8 g2, u8 b2)
{
  int y1, cb1, cr1, y2, cb2, cr2, cb, cr;

  y1 = (299 * r1 + 587 * g1 + 114 * b1) / 1000;
  cb1 = (-16874 * r1 - 33126 * g1 + 50000 * b1 + 12800000) / 100000;
  cr1 = (50000 * r1 - 41869 * g1 - 8131 * b1 + 12800000) / 100000;

  y2 = (299 * r2 + 587 * g2 + 114 * b2) / 1000;
  cb2 = (-16874 * r2 - 33126 * g2 + 50000 * b2 + 12800000) / 100000;
  cr2 = (50000 * r2 - 41869 * g2 - 8131 * b2 + 12800000) / 100000;

  cb = (cb1 + cb2) >> 1;
  cr = (cr1 + cr2) >> 1;

  return (y1 << 24) | (cb << 16) | (y2 << 8) | cr;
}

void convAtariPalToRGB(void){
	int i;
	
	 for (i = 0; i < 16; i++) {
            rgb_pal[i].b = 36 * (vid_col[i] & 0x7);
            rgb_pal[i].g = 36 * ((vid_col[i] >> 4) & 0x7);
            rgb_pal[i].r = 36 * ((vid_col[i] >> 8) & 0x7);
        }

}

int main(int argc, char **argv) {

	VIDEO_Init();
	PAD_Init();
	
	switch(VIDEO_GetCurrentTvMode()) {
		case VI_NTSC:
			rmode = &TVNtsc480IntDf;
			break;
		case VI_PAL:
			rmode = &TVPal528IntDf;
			break;
		case VI_MPAL:
			rmode = &TVMpal480IntDf;
			break;
		default:
			rmode = &TVNtsc480IntDf;
			break;
	}

	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();
	printf("\n");
	printf("          NoNameNo Proudly Presents AtaWii Beta 1.0\n\n");
	Init();

    unsigned long VideoOffset;
    unsigned char *VideoMemory;
    int i,j,x=0,y=0; // wii
    int xa=0,ya=0;  // atari
    int xm=0,ym=0;  // mousse 
    int pix_prov[16];
    u32 wii_pix_prov[8];
    u32 toto;
    int xpad=80,ypad=150*320;

 
	

	while(1) {
   		VideoOffset = vid_baseh;
    		VideoOffset <<= 8;
    		VideoOffset |= vid_basem;
    		VideoOffset <<= 8;
    		VideoMemory = ((unsigned char *)membase) + VideoOffset;
		
		if (vid_flag) {
			vid_flag=0;
			convAtariPalToRGB();
		}
		for(ya=0;ya<200;ya++){
			for(xa=0;xa<160;xa+=8){
				pix_prov[0] = ((*(VideoMemory+6+xa+ya*160) >> 4) & 0x8) | ((*(VideoMemory+4+xa+ya*160) >> 5) & 0x4) | ((*(VideoMemory+2+xa+ya*160) >> 6) & 0x2) | ((*(VideoMemory+0+xa+ya*160) >> 7) & 0x1);
				pix_prov[1] = ((*(VideoMemory+6+xa+ya*160) >> 3) & 0x8) | ((*(VideoMemory+4+xa+ya*160) >> 4) & 0x4) | ((*(VideoMemory+2+xa+ya*160) >> 5) & 0x2) | ((*(VideoMemory+0+xa+ya*160) >> 6) & 0x1);
				pix_prov[2] = ((*(VideoMemory+6+xa+ya*160) >> 2) & 0x8) | ((*(VideoMemory+4+xa+ya*160) >> 3) & 0x4) | ((*(VideoMemory+2+xa+ya*160) >> 4) & 0x2) | ((*(VideoMemory+0+xa+ya*160) >> 5) & 0x1);
				pix_prov[3] = ((*(VideoMemory+6+xa+ya*160) >> 1) & 0x8) | ((*(VideoMemory+4+xa+ya*160) >> 2) & 0x4) | ((*(VideoMemory+2+xa+ya*160) >> 3) & 0x2) | ((*(VideoMemory+0+xa+ya*160) >> 4) & 0x1);

				pix_prov[4] = ((*(VideoMemory+6+xa+ya*160)) & 0x8)      | ((*(VideoMemory+4+xa+ya*160) >> 1) & 0x4) | ((*(VideoMemory+2+xa+ya*160) >> 2) & 0x2) | ((*(VideoMemory+0+xa+ya*160) >> 3) & 0x1);
				pix_prov[5] = ((*(VideoMemory+6+xa+ya*160) << 1) & 0x8) | ((*(VideoMemory+4+xa+ya*160)) & 0x4)      | ((*(VideoMemory+2+xa+ya*160) >> 1) & 0x2) | ((*(VideoMemory+0+xa+ya*160) >> 2) & 0x1);
				pix_prov[6] = ((*(VideoMemory+6+xa+ya*160) << 2) & 0x8) | ((*(VideoMemory+4+xa+ya*160) << 1) & 0x4) | ((*(VideoMemory+2+xa+ya*160)) & 0x2)      | ((*(VideoMemory+0+xa+ya*160) >> 1) & 0x1);
				pix_prov[7] = ((*(VideoMemory+6+xa+ya*160) << 3) & 0x8) | ((*(VideoMemory+4+xa+ya*160) << 2) & 0x4) | ((*(VideoMemory+2+xa+ya*160) << 1) & 0x2) | ((*(VideoMemory+0+xa+ya*160)) & 0x1);

				pix_prov[8] = ((*(VideoMemory+7+xa+ya*160) >> 4) & 0x8) | ((*(VideoMemory+5+xa+ya*160) >> 5) & 0x4) | ((*(VideoMemory+3+xa+ya*160) >> 6) & 0x2) | ((*(VideoMemory+1+xa+ya*160) >> 7) & 0x1);
				pix_prov[9] = ((*(VideoMemory+7+xa+ya*160) >> 3) & 0x8) | ((*(VideoMemory+5+xa+ya*160) >> 4) & 0x4) | ((*(VideoMemory+3+xa+ya*160) >> 5) & 0x2) | ((*(VideoMemory+1+xa+ya*160) >> 6) & 0x1);
				pix_prov[10]= ((*(VideoMemory+7+xa+ya*160) >> 2) & 0x8) | ((*(VideoMemory+5+xa+ya*160) >> 3) & 0x4) | ((*(VideoMemory+3+xa+ya*160) >> 4) & 0x2) | ((*(VideoMemory+1+xa+ya*160) >> 5) & 0x1);
				pix_prov[11]= ((*(VideoMemory+7+xa+ya*160) >> 1) & 0x8) | ((*(VideoMemory+5+xa+ya*160) >> 2) & 0x4) | ((*(VideoMemory+3+xa+ya*160) >> 3) & 0x2) | ((*(VideoMemory+1+xa+ya*160) >> 4) & 0x1);

				pix_prov[12]= ((*(VideoMemory+7+xa+ya*160)) & 0x8)      | ((*(VideoMemory+5+xa+ya*160) >> 1) & 0x4) | ((*(VideoMemory+3+xa+ya*160) >> 2) & 0x2) | ((*(VideoMemory+1+xa+ya*160) >> 3) & 0x1);
				pix_prov[13]= ((*(VideoMemory+7+xa+ya*160) << 1) & 0x8) | ((*(VideoMemory+5+xa+ya*160)) & 0x4)      | ((*(VideoMemory+3+xa+ya*160) >> 1) & 0x2) | ((*(VideoMemory+1+xa+ya*160) >> 2) & 0x1);
				pix_prov[14]= ((*(VideoMemory+7+xa+ya*160) << 2) & 0x8) | ((*(VideoMemory+5+xa+ya*160) << 1) & 0x4) | ((*(VideoMemory+3+xa+ya*160)) & 0x2)      | ((*(VideoMemory+1+xa+ya*160) >> 1) & 0x1);
				pix_prov[15]= ((*(VideoMemory+7+xa+ya*160) << 3) & 0x8) | ((*(VideoMemory+5+xa+ya*160) << 2) & 0x4) | ((*(VideoMemory+3+xa+ya*160) << 1) & 0x2) | ((*(VideoMemory+1+xa+ya*160)) & 0x1);


				wii_pix_prov[0]=CvtRGB(rgb_pal[pix_prov[0]].r,rgb_pal[pix_prov[0]].g,rgb_pal[pix_prov[0]].b,rgb_pal[pix_prov[1]].r,rgb_pal[pix_prov[1]].g,rgb_pal[pix_prov[1]].b);
				wii_pix_prov[1]=CvtRGB(rgb_pal[pix_prov[2]].r,rgb_pal[pix_prov[2]].g,rgb_pal[pix_prov[2]].b,rgb_pal[pix_prov[3]].r,rgb_pal[pix_prov[3]].g,rgb_pal[pix_prov[3]].b);
				wii_pix_prov[2]=CvtRGB(rgb_pal[pix_prov[4]].r,rgb_pal[pix_prov[4]].g,rgb_pal[pix_prov[4]].b,rgb_pal[pix_prov[5]].r,rgb_pal[pix_prov[5]].g,rgb_pal[pix_prov[5]].b);
				wii_pix_prov[3]=CvtRGB(rgb_pal[pix_prov[6]].r,rgb_pal[pix_prov[6]].g,rgb_pal[pix_prov[6]].b,rgb_pal[pix_prov[7]].r,rgb_pal[pix_prov[7]].g,rgb_pal[pix_prov[7]].b);
				wii_pix_prov[4]=CvtRGB(rgb_pal[pix_prov[8]].r,rgb_pal[pix_prov[8]].g,rgb_pal[pix_prov[8]].b,rgb_pal[pix_prov[9]].r,rgb_pal[pix_prov[9]].g,rgb_pal[pix_prov[9]].b);
				wii_pix_prov[5]=CvtRGB(rgb_pal[pix_prov[10]].r,rgb_pal[pix_prov[10]].g,rgb_pal[pix_prov[10]].b,rgb_pal[pix_prov[11]].r,rgb_pal[pix_prov[11]].g,rgb_pal[pix_prov[11]].b);
				wii_pix_prov[6]=CvtRGB(rgb_pal[pix_prov[12]].r,rgb_pal[pix_prov[12]].g,rgb_pal[pix_prov[12]].b,rgb_pal[pix_prov[13]].r,rgb_pal[pix_prov[13]].g,rgb_pal[pix_prov[13]].b);
				wii_pix_prov[7]=CvtRGB(rgb_pal[pix_prov[14]].r,rgb_pal[pix_prov[14]].g,rgb_pal[pix_prov[14]].b,rgb_pal[pix_prov[15]].r,rgb_pal[pix_prov[15]].g,rgb_pal[pix_prov[15]].b);
				xfb[0+xpad+ypad+xa+ya*320]=wii_pix_prov[0];
				xfb[1+xpad+ypad+xa+ya*320]=wii_pix_prov[1];
				xfb[2+xpad+ypad+xa+ya*320]=wii_pix_prov[2];
				xfb[3+xpad+ypad+xa+ya*320]=wii_pix_prov[3];
				xfb[4+xpad+ypad+xa+ya*320]=wii_pix_prov[4];
				xfb[5+xpad+ypad+xa+ya*320]=wii_pix_prov[5];
				xfb[6+xpad+ypad+xa+ya*320]=wii_pix_prov[6];
				xfb[7+xpad+ypad+xa+ya*320]=wii_pix_prov[7];

			}
			
			
		}	

		//j=0;
		//for(i=0;i<200*4;i+=4){
		//	memcpy(xfb+j*640,VideoMemory+i*320,320);
		//	j++;
		//}
		


		CPURun(6000);
		
				
		VIDEO_WaitVSync();
		PAD_ScanPads ();
		if (PAD_ButtonsDown(0) & PAD_BUTTON_START){
			reload ();
		}

		if (PAD_ButtonsDown(0) & PAD_TRIGGER_R){
			HWReset();
		}


		if (PAD_ButtonsDown(0) & PAD_BUTTON_DOWN){
			VideoMemory+=160*200;
		}
		if (PAD_ButtonsDown(0) & PAD_TRIGGER_L){
			IkbdKeyPress(57);
			IkbdKeyPress(185);
			
		}
		if (PAD_ButtonsDown(0) & PAD_BUTTON_B){
			IkbdKeyPress(59);
			IkbdKeyPress(187);
			
		}
		if (PAD_ButtonsDown(0) & PAD_BUTTON_A){
			IkbdKeyPress(60);
			IkbdKeyPress(188);
			
		}
		if (PAD_ButtonsDown(0) & PAD_BUTTON_Y){
			IkbdKeyPress(61);
			IkbdKeyPress(189);
			
		}
		if (PAD_ButtonsDown(0) & PAD_BUTTON_X){
			IkbdKeyPress(62);
			IkbdKeyPress(190);
			
		}

		if (PAD_ButtonsDown(0) & PAD_BUTTON_UP){
			IkbdKeyPress(72);
			IkbdKeyPress(200);
			
		}

		if (PAD_ButtonsDown(0) & PAD_BUTTON_DOWN){
			IkbdKeyPress(80);
			IkbdKeyPress(208);
			
		}


		VBlank();
		IkbdQueryBuffer();
		IkbdWriteBuffer();
		SetInterruptPriority();
		

    	}


	return 0;
}















